defmodule Hafnium.Config do
  @moduledoc false

  @spec fetch(atom()) :: any()
  def fetch(key), do: Application.fetch_env!(:hafnium, key)

  def get(key, default), do: Application.get_env(:hafnium, key, default)

  @before_pipelines [Hafnium.Pipelines.SaveInput]
  @after_pipelines []

  def before_pipelines, do: get(:before_pipelines, @before_pipelines)
  def after_pipelines, do: get(:after_pipelines, @after_pipelines)
end
